#Module with the commands to the equipment Syringe Pump

package provide slm_04 0.0

puts "Loaded [info script]"

namespace eval slm_04	 {
    
    variable time_out 100 pin_number d11 serial_controller dfc transaction_id id
    
    #namespace export setPosition checkConnection

    #startPump;[id_pump];[set_point];[interval];[id_transaction]

    proc startPump { id_pump set_point interval } {
	
	variable serial_controller; variable transaction_id 

	puts "slm_04 command startPump id_pump:$id_pump set_point:$set_point interval:$interval transaction_id:$transaction_id"

	set rtn [$serial_controller sendCommand "startPump;$id_pump;$set_point;$interval;$transaction_id"]
	
        if { $rtn == "COMMAND_SENT" } {

	   return "ACK;startPump;$id_pump;$set_point;$interval;$transaction_id"

	} else {

	   return "NACK;$rtn"

        }
    }

    #serial_controller dataFlowController
    #stopPump;[id_pump];[id_transaction]		

    proc stopPump { id_pump } {

    	 variable serial_controller; variable transaction_id
	 
      	 puts "Command stopPump slm_04 id_pump:$id_pump transaction_id:$transaction_id\n"

	 $serial_controller sendCommand "stopPump;$id_pump;$transaction_id"

    }

     #serial_controller dataFlowController
    proc checkConnection { serial_controller transaction_id } {

         variable timeout; variable pin_number

         puts "Command checkConnection of slm_02 serial_controller: $serial_controller\n"

         $serial_controller sendCommand "checkConnection;$transaction_id"
	 
    }

    #serial_controller dataFlowController
    proc init { serial_controller transaction_id } {

         puts "Module slm_01 command init"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

    }

    #serial_controller dataFlowController
    proc end_init { serial_controller transaction_id } {

         puts "Module slm_01 command end_init"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

   }

    #serial_controller dataFlowController
    proc error_init { serial_controller transaction_id } {

         puts "Module slm_01 command error_init"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

    }

    #serial_controller dataFlowController
    proc setup { serial_controller transaction_id } {

         puts "Module slm_01 command setup"

         #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"
	 
    }

    #serial_controller dataFlowController
    proc end_setup { serial_controller transaction_id } {

         puts "Module slm_01 command end_setup"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"
    }

    #serial_controller dataFlowController
    proc error_setup { serial_controller transaction_id } {

         puts "Module slm_01 command error_setup"

	 #return "ACK"

	 $serial_controller sendCommand "checkConnection;$transaction_id"

    }

    proc setInternalArgs { s_c t_id } {

    	 variable serial_controller; variable transaction_id

	 puts "\nProcedure setInternalArgs $s_c and $t_id\n"

	 set serial_controller $s_c
	 set transaction_id $t_id

    }
    
}
